image: docker:latest

stages:
  - build
  - test
  - deploy
  - test-deployment

variables:
  DOCKER_DRIVER: overlay2

cache:
  paths:
    - .m2/repository

before_script:
  - export COMMIT_SHORT_SHA=$(echo "$CI_COMMIT_SHA" | cut -c1-8)

build:
  stage: build
  script:
    - docker build -t localhost-docker-registry/demo-app:latest .
  only:
    - master

test:
  stage: test
  script:
    - docker run --rm localhost-docker-registry/demo-app:latest mvn test
  only:
    - master

deploy:
  stage: deploy
  script:
    - docker push localhost-docker-registry/demo-app:latest
  only:
    - master

test-deployment:
  stage: test-deployment
  script:
    - kubectl apply -f deployment.yml
    - sleep 60s # Attendre que le déploiement soit complètement opérationnel
    - curl http://localhost:8080/ # Remplacez CLUSTER_IP par l'IP du cluster Kubernetes
  only:
    - master
